Code

0b15924006b2307eb70308dcf854c05e7dd05c98
[git.git] / git-merge.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git-merge [options] <remote>...
9 git-merge [options] <msg> HEAD <remote>
10 --
11 stat                 show a diffstat at the end of the merge
12 n,no-stat            don't show a diffstat at the end of the merge
13 summary              (synonym to --stat)
14 no-summary           (synonym to --no-stat)
15 squash               create a single commit instead of doing a merge
16 commit               perform a commit if the merge sucesses (default)
17 ff                   allow fast forward (default)
18 s,strategy=          merge strategy to use
19 m,message=           message to be used for the merge commit (if any)
20 "
22 SUBDIRECTORY_OK=Yes
23 . git-sh-setup
24 require_work_tree
25 cd_to_toplevel
27 test -z "$(git ls-files -u)" ||
28         die "You are in the middle of a conflicted merge."
30 LF='
31 '
33 all_strategies='recur recursive octopus resolve stupid ours subtree'
34 default_twohead_strategies='recursive'
35 default_octopus_strategies='octopus'
36 no_fast_forward_strategies='subtree ours'
37 no_trivial_strategies='recursive recur subtree ours'
38 use_strategies=
40 allow_fast_forward=t
41 allow_trivial_merge=t
42 squash= no_commit=
44 dropsave() {
45         rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
46                  "$GIT_DIR/MERGE_STASH" || exit 1
47 }
49 savestate() {
50         # Stash away any local modifications.
51         git stash create >"$GIT_DIR/MERGE_STASH"
52 }
54 restorestate() {
55         if test -f "$GIT_DIR/MERGE_STASH"
56         then
57                 git reset --hard $head >/dev/null
58                 git stash apply $(cat "$GIT_DIR/MERGE_STASH")
59                 git update-index --refresh >/dev/null
60         fi
61 }
63 finish_up_to_date () {
64         case "$squash" in
65         t)
66                 echo "$1 (nothing to squash)" ;;
67         '')
68                 echo "$1" ;;
69         esac
70         dropsave
71 }
73 squash_message () {
74         echo Squashed commit of the following:
75         echo
76         git log --no-merges --pretty=medium ^"$head" $remoteheads
77 }
79 finish () {
80         if test '' = "$2"
81         then
82                 rlogm="$GIT_REFLOG_ACTION"
83         else
84                 echo "$2"
85                 rlogm="$GIT_REFLOG_ACTION: $2"
86         fi
87         case "$squash" in
88         t)
89                 echo "Squash commit -- not updating HEAD"
90                 squash_message >"$GIT_DIR/SQUASH_MSG"
91                 ;;
92         '')
93                 case "$merge_msg" in
94                 '')
95                         echo "No merge message -- not updating HEAD"
96                         ;;
97                 *)
98                         git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
99                         git gc --auto
100                         ;;
101                 esac
102                 ;;
103         esac
104         case "$1" in
105         '')
106                 ;;
107         ?*)
108                 if test "$show_diffstat" = t
109                 then
110                         # We want color (if set), but no pager
111                         GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
112                 fi
113                 ;;
114         esac
116         # Run a post-merge hook
117         if test -x "$GIT_DIR"/hooks/post-merge
118         then
119             case "$squash" in
120             t)
121                 "$GIT_DIR"/hooks/post-merge 1
122                 ;;
123             '')
124                 "$GIT_DIR"/hooks/post-merge 0
125                 ;;
126             esac
127         fi
130 merge_name () {
131         remote="$1"
132         rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
133         bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
134         if test "$rh" = "$bh"
135         then
136                 echo "$rh               branch '$remote' of ."
137         elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
138                 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
139         then
140                 echo "$rh               branch '$truname' (early part) of ."
141         elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
142         then
143                 sed -e 's/      not-for-merge   /               /' -e 1q \
144                         "$GIT_DIR/FETCH_HEAD"
145         else
146                 echo "$rh               commit '$remote'"
147         fi
150 parse_config () {
151         while test $# != 0; do
152                 case "$1" in
153                 -n|--no-stat|--no-summary)
154                         show_diffstat=false ;;
155                 --stat|--summary)
156                         show_diffstat=t ;;
157                 --squash)
158                         test "$allow_fast_forward" = t ||
159                                 die "You cannot combine --squash with --no-ff."
160                         squash=t no_commit=t ;;
161                 --no-squash)
162                         squash= no_commit= ;;
163                 --commit)
164                         no_commit= ;;
165                 --no-commit)
166                         no_commit=t ;;
167                 --ff)
168                         allow_fast_forward=t ;;
169                 --no-ff)
170                         test "$squash" != t ||
171                                 die "You cannot combine --squash with --no-ff."
172                         allow_fast_forward=f ;;
173                 -s|--strategy)
174                         shift
175                         case " $all_strategies " in
176                         *" $1 "*)
177                                 use_strategies="$use_strategies$1 " ;;
178                         *)
179                                 die "available strategies are: $all_strategies" ;;
180                         esac
181                         ;;
182                 -m|--message)
183                         shift
184                         merge_msg="$1"
185                         have_message=t
186                         ;;
187                 --)
188                         shift
189                         break ;;
190                 *)      usage ;;
191                 esac
192                 shift
193         done
194         args_left=$#
197 test $# != 0 || usage
199 have_message=
201 if branch=$(git-symbolic-ref -q HEAD)
202 then
203         mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
204         if test -n "$mergeopts"
205         then
206                 parse_config $mergeopts --
207         fi
208 fi
210 parse_config "$@"
211 while test $args_left -lt $#; do shift; done
213 if test -z "$show_diffstat"; then
214     test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
215     test -z "$show_diffstat" && show_diffstat=t
216 fi
218 # This could be traditional "merge <msg> HEAD <commit>..."  and the
219 # way we can tell it is to see if the second token is HEAD, but some
220 # people might have misused the interface and used a committish that
221 # is the same as HEAD there instead.  Traditional format never would
222 # have "-m" so it is an additional safety measure to check for it.
224 if test -z "$have_message" &&
225         second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
226         head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
227         test "$second_token" = "$head_commit"
228 then
229         merge_msg="$1"
230         shift
231         head_arg="$1"
232         shift
233 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
234 then
235         # If the merged head is a valid one there is no reason to
236         # forbid "git merge" into a branch yet to be born.  We do
237         # the same for "git pull".
238         if test 1 -ne $#
239         then
240                 echo >&2 "Can merge only exactly one commit into empty head"
241                 exit 1
242         fi
244         rh=$(git rev-parse --verify "$1^0") ||
245                 die "$1 - not something we can merge"
247         git update-ref -m "initial pull" HEAD "$rh" "" &&
248         git read-tree --reset -u HEAD
249         exit
251 else
252         # We are invoked directly as the first-class UI.
253         head_arg=HEAD
255         # All the rest are the commits being merged; prepare
256         # the standard merge summary message to be appended to
257         # the given message.  If remote is invalid we will die
258         # later in the common codepath so we discard the error
259         # in this loop.
260         merge_name=$(for remote
261                 do
262                         merge_name "$remote"
263                 done | git fmt-merge-msg
264         )
265         merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
266 fi
267 head=$(git rev-parse --verify "$head_arg"^0) || usage
269 # All the rest are remote heads
270 test "$#" = 0 && usage ;# we need at least one remote head.
271 set_reflog_action "merge $*"
273 remoteheads=
274 for remote
275 do
276         remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
277             die "$remote - not something we can merge"
278         remoteheads="${remoteheads}$remotehead "
279         eval GITHEAD_$remotehead='"$remote"'
280         export GITHEAD_$remotehead
281 done
282 set x $remoteheads ; shift
284 case "$use_strategies" in
285 '')
286         case "$#" in
287         1)
288                 var="`git config --get pull.twohead`"
289                 if test -n "$var"
290                 then
291                         use_strategies="$var"
292                 else
293                         use_strategies="$default_twohead_strategies"
294                 fi ;;
295         *)
296                 var="`git config --get pull.octopus`"
297                 if test -n "$var"
298                 then
299                         use_strategies="$var"
300                 else
301                         use_strategies="$default_octopus_strategies"
302                 fi ;;
303         esac
304         ;;
305 esac
307 for s in $use_strategies
308 do
309         for ss in $no_fast_forward_strategies
310         do
311                 case " $s " in
312                 *" $ss "*)
313                         allow_fast_forward=f
314                         break
315                         ;;
316                 esac
317         done
318         for ss in $no_trivial_strategies
319         do
320                 case " $s " in
321                 *" $ss "*)
322                         allow_trivial_merge=f
323                         break
324                         ;;
325                 esac
326         done
327 done
329 case "$#" in
330 1)
331         common=$(git merge-base --all $head "$@")
332         ;;
333 *)
334         common=$(git show-branch --merge-base $head "$@")
335         ;;
336 esac
337 echo "$head" >"$GIT_DIR/ORIG_HEAD"
339 case "$allow_fast_forward,$#,$common,$no_commit" in
340 ?,*,'',*)
341         # No common ancestors found. We need a real merge.
342         ;;
343 ?,1,"$1",*)
344         # If head can reach all the merge then we are up to date.
345         # but first the most common case of merging one remote.
346         finish_up_to_date "Already up-to-date."
347         exit 0
348         ;;
349 t,1,"$head",*)
350         # Again the most common case of merging one remote.
351         echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
352         git update-index --refresh 2>/dev/null
353         msg="Fast forward"
354         if test -n "$have_message"
355         then
356                 msg="$msg (no commit created; -m option ignored)"
357         fi
358         new_head=$(git rev-parse --verify "$1^0") &&
359         git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
360         finish "$new_head" "$msg" || exit
361         dropsave
362         exit 0
363         ;;
364 ?,1,?*"$LF"?*,*)
365         # We are not doing octopus and not fast forward.  Need a
366         # real merge.
367         ;;
368 ?,1,*,)
369         # We are not doing octopus, not fast forward, and have only
370         # one common.
371         git update-index --refresh 2>/dev/null
372         case "$allow_trivial_merge" in
373         t)
374                 # See if it is really trivial.
375                 git var GIT_COMMITTER_IDENT >/dev/null || exit
376                 echo "Trying really trivial in-index merge..."
377                 if git read-tree --trivial -m -u -v $common $head "$1" &&
378                    result_tree=$(git write-tree)
379                 then
380                         echo "Wonderful."
381                         result_commit=$(
382                                 printf '%s\n' "$merge_msg" |
383                                 git commit-tree $result_tree -p HEAD -p "$1"
384                         ) || exit
385                         finish "$result_commit" "In-index merge"
386                         dropsave
387                         exit 0
388                 fi
389                 echo "Nope."
390         esac
391         ;;
392 *)
393         # An octopus.  If we can reach all the remote we are up to date.
394         up_to_date=t
395         for remote
396         do
397                 common_one=$(git merge-base --all $head $remote)
398                 if test "$common_one" != "$remote"
399                 then
400                         up_to_date=f
401                         break
402                 fi
403         done
404         if test "$up_to_date" = t
405         then
406                 finish_up_to_date "Already up-to-date. Yeeah!"
407                 exit 0
408         fi
409         ;;
410 esac
412 # We are going to make a new commit.
413 git var GIT_COMMITTER_IDENT >/dev/null || exit
415 # At this point, we need a real merge.  No matter what strategy
416 # we use, it would operate on the index, possibly affecting the
417 # working tree, and when resolved cleanly, have the desired tree
418 # in the index -- this means that the index must be in sync with
419 # the $head commit.  The strategies are responsible to ensure this.
421 case "$use_strategies" in
422 ?*' '?*)
423     # Stash away the local changes so that we can try more than one.
424     savestate
425     single_strategy=no
426     ;;
427 *)
428     rm -f "$GIT_DIR/MERGE_STASH"
429     single_strategy=yes
430     ;;
431 esac
433 result_tree= best_cnt=-1 best_strategy= wt_strategy=
434 merge_was_ok=
435 for strategy in $use_strategies
436 do
437     test "$wt_strategy" = '' || {
438         echo "Rewinding the tree to pristine..."
439         restorestate
440     }
441     case "$single_strategy" in
442     no)
443         echo "Trying merge strategy $strategy..."
444         ;;
445     esac
447     # Remember which strategy left the state in the working tree
448     wt_strategy=$strategy
450     git-merge-$strategy $common -- "$head_arg" "$@"
451     exit=$?
452     if test "$no_commit" = t && test "$exit" = 0
453     then
454         merge_was_ok=t
455         exit=1 ;# pretend it left conflicts.
456     fi
458     test "$exit" = 0 || {
460         # The backend exits with 1 when conflicts are left to be resolved,
461         # with 2 when it does not handle the given merge at all.
463         if test "$exit" -eq 1
464         then
465             cnt=`{
466                 git diff-files --name-only
467                 git ls-files --unmerged
468             } | wc -l`
469             if test $best_cnt -le 0 -o $cnt -le $best_cnt
470             then
471                 best_strategy=$strategy
472                 best_cnt=$cnt
473             fi
474         fi
475         continue
476     }
478     # Automerge succeeded.
479     result_tree=$(git write-tree) && break
480 done
482 # If we have a resulting tree, that means the strategy module
483 # auto resolved the merge cleanly.
484 if test '' != "$result_tree"
485 then
486     if test "$allow_fast_forward" = "t"
487     then
488         parents=$(git show-branch --independent "$head" "$@")
489     else
490         parents=$(git rev-parse "$head" "$@")
491     fi
492     parents=$(echo "$parents" | sed -e 's/^/-p /')
493     result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
494     finish "$result_commit" "Merge made by $wt_strategy."
495     dropsave
496     exit 0
497 fi
499 # Pick the result from the best strategy and have the user fix it up.
500 case "$best_strategy" in
501 '')
502         restorestate
503         case "$use_strategies" in
504         ?*' '?*)
505                 echo >&2 "No merge strategy handled the merge."
506                 ;;
507         *)
508                 echo >&2 "Merge with strategy $use_strategies failed."
509                 ;;
510         esac
511         exit 2
512         ;;
513 "$wt_strategy")
514         # We already have its result in the working tree.
515         ;;
516 *)
517         echo "Rewinding the tree to pristine..."
518         restorestate
519         echo "Using the $best_strategy to prepare resolving by hand."
520         git-merge-$best_strategy $common -- "$head_arg" "$@"
521         ;;
522 esac
524 if test "$squash" = t
525 then
526         finish
527 else
528         for remote
529         do
530                 echo $remote
531         done >"$GIT_DIR/MERGE_HEAD"
532         printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
533 fi
535 if test "$merge_was_ok" = t
536 then
537         echo >&2 \
538         "Automatic merge went well; stopped before committing as requested"
539         exit 0
540 else
541         {
542             echo '
543 Conflicts:
545                 git ls-files --unmerged |
546                 sed -e 's/^[^   ]*      /       /' |
547                 uniq
548         } >>"$GIT_DIR/MERGE_MSG"
549         git rerere
550         die "Automatic merge failed; fix conflicts and then commit the result."
551 fi